"use strict";

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var getListLevel = function getListLevel(list) {
  var numList = list.map(function (item) {
    return Array.isArray(item) ? getListLevel(item) + 1 : 1;
  });
  return Math.max.apply(Math, _toConsumableArray(numList));
};

var makeSpace = function makeSpace(_x, _x2) {
  var _again = true;

  _function: while (_again) {
    var buffer = _x,
        n = _x2;
    _again = false;

    if (n > 0) {
      _x = buffer + " ";
      _x2 = n - 1;
      _again = true;
      continue _function;
    } else {
      return buffer;
    }
  }
};

exports.spaces = function (n) {
  return makeSpace("", n);
};

exports.type = function (x) {
  var info = Object.prototype.toString.call(x),
      theType = info.slice(8, -1);
  return theType.toLowerCase();
};

exports.markToken = function (text) {
  return text.match(/^[^\"\s\(\)]+$/) ? text : JSON.stringify(text);
};

exports.isPlain = function (list) {
  return list.every(function (child) {
    return exports.type(child) === "string";
  });
};

exports.isArray = function (x) {
  return exports.type(x) === "array";
};

exports.isDeep = function (ast) {
  return Array.isArray(ast) ? getListLevel(ast) > 2 : false;
};

var trimRightSpace = function trimRightSpace(_x3) {
  var _again2 = true;

  _function2: while (_again2) {
    var text = _x3;
    _again2 = false;
    var end = text.length - 1,
        last = text[end];

    if (last === " ") {
      _x3 = text.substr(0, end);
      _again2 = true;
      end = last = undefined;
      continue _function2;
    } else {
      return text;
    }
  }
};

exports.trimRightSpace = function (text) {
  return trimRightSpace(text);
};