"use strict";

var util = require("./util"),
    transformer = require("./transformer"),
    noLuckyChild;

exports.render = function (ast) {
  undefined;
  undefined;
  undefined;
  undefined;
  ast = transformer.insertDollar(transformer.insertComma(ast));
  undefined;

  var buffer = "",
      indent = -1,
      mode = "line",
      renderSpan = function renderSpan(text) {
    undefined;
    return buffer = buffer + text;
  },
      renderNewline = function renderNewline() {
    buffer = util.trimRightSpace(buffer);
    renderSpan("\n");
    return renderSpan(util.spaces(indent * 2));
  },
      increaseIndent = function increaseIndent() {
    return indent = indent + 1;
  },
      decreaseIndent = function decreaseIndent() {
    return indent = indent - 1;
  };

  var render = function render(node, parent, index, inline, lucky) {
    undefined;

    switch (util.type(node)) {
      case "string":
        switch (mode) {
          case "line":
            throw "No string should be at line after comma inserted!";
            break;

          case "text":
            renderSpan(" ");
            renderSpan(util.markToken(node));
            break;

          case "start":
            renderSpan(util.markToken(node));
            mode = "text";
            break;
        }

        break;

      case "array":
        switch (mode) {
          case "line":
            renderNewline();

            if (util.isDeep(parent[index - 1])) {
              renderNewline();
            }

            mode = "start";
            increaseIndent();
            noLuckyChild = true;
            node.forEach(function (child, i) {
              render(child, node, i, i === 0, noLuckyChild);

              if (util.isArray(child)) {
                noLuckyChild = false;
              }

              return;
            });
            decreaseIndent();
            mode = "line";
            break;

          case "text":
            if (inline) {
              renderSpan(" (");
              mode = "start";
              node.forEach(function (child, i) {
                return render(child, node, i, i === 0, true);
              });
              renderSpan(")");
              mode = "text";
              return null;
            }

            if (util.isPlain(node) && lucky) {
              renderSpan(" (");
              mode = "start";
              node.forEach(function (child, i) {
                return render(child, node, i, i === 0, true);
              });
              renderSpan(")");
              mode = "text";
            } else {
              renderNewline();
              mode = "start";
              increaseIndent();
              noLuckyChild = true;
              node.forEach(function (child, i) {
                render(child, node, i, i === 0, noLuckyChild);

                if (util.isArray(child)) {
                  noLuckyChild = false;
                }

                return;
              });
              decreaseIndent();
              mode = "line";
            }

            break;

          case "start":
            if (inline && parent !== ast) {
              renderSpan("(");
              mode = "start";
              node.forEach(function (child, i) {
                return render(child, node, i, true, false);
              });
              renderSpan(")");
              mode = "text";
            } else {
              increaseIndent();
              noLuckyChild = true;
              node.forEach(function (child, i) {
                render(child, node, i, i === 0, true);

                if (util.isArray(child)) {
                  noLuckyChild = false;
                }

                return;
              });
              decreaseIndent();
              mode = "line";
            }

            break;
        }

        break;
    }

    return buffer + "\n";
  };

  if (!ast.every(util.isArray)) {
    throw new Error("Cirru AST uses nested arrays");
  }

  return render(ast, [], 1, false, false);
};